import{s as tt,n as ot,o as nt}from"../chunks/scheduler.8c3d61f6.js";import{S as rt,i as st,g as a,s as r,r as u,A as lt,h as i,f as t,c as s,j as b,u as m,x as $,k as _,y as o,a as c,v as p,d as f,t as g,w as h}from"../chunks/index.da70eac4.js";import{D as v}from"../chunks/Docstring.567bc132.js";import{C as at}from"../chunks/CodeBlock.a9c4becf.js";import{H as ke,E as it}from"../chunks/index.5d4ab994.js";function dt(Pe){let A,se,ne,le,T,ae,K,ze='The 3D variational autoencoder (VAE) model with KL loss used in <a href="https://github.com/rhymes-ai/Allegro" rel="nofollow">Allegro</a> was introduced in <a href="https://huggingface.co/papers/2410.15458" rel="nofollow">Allegro: Open the Black Box of Commercial-Level Video Generation Model</a> by RhymesAI.',ie,M,He="The model can be loaded with the following code snippet.",de,E,ce,V,ue,l,C,xe,N,je=`A VAE model with KL loss for encoding videos into latents and decoding latent representations into videos. Used in
<a href="https://github.com/rhymes-ai/Allegro" rel="nofollow">Allegro</a>.`,De,Z,Je=`This model inherits from <a href="/docs/diffusers/main/en/api/models/overview#diffusers.ModelMixin">ModelMixin</a>. Check the superclass documentation for it’s generic methods implemented
for all models (such as downloading or saving).`,Te,R,q,Ke,S,B,Me,L,I,Ee,W,Ne=`Disable sliced VAE decoding. If <code>enable_slicing</code> was previously enabled, this method will go back to computing
decoding in one step.`,Ve,k,O,Ce,X,Ze=`Disable tiled VAE decoding. If <code>enable_tiling</code> was previously enabled, this method will go back to computing
decoding in one step.`,qe,x,F,Be,Q,Re=`Enable sliced VAE decoding. When this option is enabled, the VAE will split the input tensor in slices to
compute decoding in several steps. This is useful to save some memory and allow larger batch sizes.`,Ie,D,U,Oe,Y,Se=`Enable tiled VAE decoding. When this option is enabled, the VAE will split the input tensor into tiles to
compute decoding and encoding in several steps. This is useful for saving a large amount of memory and to allow
processing larger images.`,Fe,ee,G,me,P,pe,w,z,Ue,te,We="Output of AutoencoderKL encoding method.",fe,H,ge,y,j,Ge,oe,Xe="Output of decoding method.",he,J,be,re,_e;return T=new ke({props:{title:"AutoencoderKLAllegro",local:"autoencoderklallegro",headingTag:"h1"}}),E=new at({props:{code:"ZnJvbSUyMGRpZmZ1c2VycyUyMGltcG9ydCUyMEF1dG9lbmNvZGVyS0xBbGxlZ3JvJTBBJTBBdmFlJTIwJTNEJTIwQXV0b2VuY29kZXJLTEFsbGVncm8uZnJvbV9wcmV0cmFpbmVkKCUyMnJoeW1lcy1haSUyRkFsbGVncm8lMjIlMkMlMjBzdWJmb2xkZXIlM0QlMjJ2YWUlMjIlMkMlMjB0b3JjaF9kdHlwZSUzRHRvcmNoLmZsb2F0MzIpLnRvKCUyMmN1ZGElMjIp",highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> AutoencoderKLAllegro

vae = AutoencoderKLAllegro.from_pretrained(<span class="hljs-string">&quot;rhymes-ai/Allegro&quot;</span>, subfolder=<span class="hljs-string">&quot;vae&quot;</span>, torch_dtype=torch.float32).to(<span class="hljs-string">&quot;cuda&quot;</span>)`,wrap:!1}}),V=new ke({props:{title:"AutoencoderKLAllegro",local:"diffusers.AutoencoderKLAllegro",headingTag:"h2"}}),C=new v({props:{name:"class diffusers.AutoencoderKLAllegro",anchor:"diffusers.AutoencoderKLAllegro",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str, ...] = ('AllegroDownBlock3D', 'AllegroDownBlock3D', 'AllegroDownBlock3D', 'AllegroDownBlock3D')"},{name:"up_block_types",val:": typing.Tuple[str, ...] = ('AllegroUpBlock3D', 'AllegroUpBlock3D', 'AllegroUpBlock3D', 'AllegroUpBlock3D')"},{name:"block_out_channels",val:": typing.Tuple[int, ...] = (128, 256, 512, 512)"},{name:"temporal_downsample_blocks",val:": typing.Tuple[bool, ...] = (True, True, False, False)"},{name:"temporal_upsample_blocks",val:": typing.Tuple[bool, ...] = (False, True, True, False)"},{name:"latent_channels",val:": int = 4"},{name:"layers_per_block",val:": int = 2"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": int = 32"},{name:"temporal_compression_ratio",val:": float = 4"},{name:"sample_size",val:": int = 320"},{name:"scaling_factor",val:": float = 0.13"},{name:"force_upcast",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.AutoencoderKLAllegro.in_channels",description:`<strong>in_channels</strong> (int, defaults to <code>3</code>) &#x2014;
Number of channels in the input image.`,name:"in_channels"},{anchor:"diffusers.AutoencoderKLAllegro.out_channels",description:`<strong>out_channels</strong> (int, defaults to <code>3</code>) &#x2014;
Number of channels in the output.`,name:"out_channels"},{anchor:"diffusers.AutoencoderKLAllegro.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str, ...]</code>, defaults to <code>(&quot;AllegroDownBlock3D&quot;, &quot;AllegroDownBlock3D&quot;, &quot;AllegroDownBlock3D&quot;, &quot;AllegroDownBlock3D&quot;)</code>) &#x2014;
Tuple of strings denoting which types of down blocks to use.`,name:"down_block_types"},{anchor:"diffusers.AutoencoderKLAllegro.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str, ...]</code>, defaults to <code>(&quot;AllegroUpBlock3D&quot;, &quot;AllegroUpBlock3D&quot;, &quot;AllegroUpBlock3D&quot;, &quot;AllegroUpBlock3D&quot;)</code>) &#x2014;
Tuple of strings denoting which types of up blocks to use.`,name:"up_block_types"},{anchor:"diffusers.AutoencoderKLAllegro.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int, ...]</code>, defaults to <code>(128, 256, 512, 512)</code>) &#x2014;
Tuple of integers denoting number of output channels in each block.`,name:"block_out_channels"},{anchor:"diffusers.AutoencoderKLAllegro.temporal_downsample_blocks",description:`<strong>temporal_downsample_blocks</strong> (<code>Tuple[bool, ...]</code>, defaults to <code>(True, True, False, False)</code>) &#x2014;
Tuple of booleans denoting which blocks to enable temporal downsampling in.`,name:"temporal_downsample_blocks"},{anchor:"diffusers.AutoencoderKLAllegro.latent_channels",description:`<strong>latent_channels</strong> (<code>int</code>, defaults to <code>4</code>) &#x2014;
Number of channels in latents.`,name:"latent_channels"},{anchor:"diffusers.AutoencoderKLAllegro.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, defaults to <code>2</code>) &#x2014;
Number of resnet or attention or temporal convolution layers per down/up block.`,name:"layers_per_block"},{anchor:"diffusers.AutoencoderKLAllegro.act_fn",description:`<strong>act_fn</strong> (<code>str</code>, defaults to <code>&quot;silu&quot;</code>) &#x2014;
The activation function to use.`,name:"act_fn"},{anchor:"diffusers.AutoencoderKLAllegro.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, defaults to <code>32</code>) &#x2014;
Number of groups to use in normalization layers.`,name:"norm_num_groups"},{anchor:"diffusers.AutoencoderKLAllegro.temporal_compression_ratio",description:`<strong>temporal_compression_ratio</strong> (<code>int</code>, defaults to <code>4</code>) &#x2014;
Ratio by which temporal dimension of samples are compressed.`,name:"temporal_compression_ratio"},{anchor:"diffusers.AutoencoderKLAllegro.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, defaults to <code>320</code>) &#x2014;
Default latent size.`,name:"sample_size"},{anchor:"diffusers.AutoencoderKLAllegro.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, defaults to <code>0.13235</code>) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"},{anchor:"diffusers.AutoencoderKLAllegro.force_upcast",description:`<strong>force_upcast</strong> (<code>bool</code>, default to <code>True</code>) &#x2014;
If enabled it will force the VAE to run in float32 for high image resolution pipelines, such as SD-XL. VAE
can be fine-tuned / trained to a lower range without loosing too much precision in which case
<code>force_upcast</code> can be set to <code>False</code> - see: <a href="https://huggingface.co/madebyollin/sdxl-vae-fp16-fix" rel="nofollow">https://huggingface.co/madebyollin/sdxl-vae-fp16-fix</a>`,name:"force_upcast"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L676"}}),q=new v({props:{name:"wrapper",anchor:"diffusers.AutoencoderKLAllegro.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/utils/accelerate_utils.py#L43"}}),B=new v({props:{name:"wrapper",anchor:"diffusers.AutoencoderKLAllegro.encode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/utils/accelerate_utils.py#L43"}}),I=new v({props:{name:"disable_slicing",anchor:"diffusers.AutoencoderKLAllegro.disable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L820"}}),O=new v({props:{name:"disable_tiling",anchor:"diffusers.AutoencoderKLAllegro.disable_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L806"}}),F=new v({props:{name:"enable_slicing",anchor:"diffusers.AutoencoderKLAllegro.enable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L813"}}),U=new v({props:{name:"enable_tiling",anchor:"diffusers.AutoencoderKLAllegro.enable_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L798"}}),G=new v({props:{name:"forward",anchor:"diffusers.AutoencoderKLAllegro.forward",parameters:[{name:"sample",val:": Tensor"},{name:"sample_posterior",val:": bool = False"},{name:"return_dict",val:": bool = True"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"}],parametersDescription:[{anchor:"diffusers.AutoencoderKLAllegro.forward.sample",description:"<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.AutoencoderKLAllegro.forward.sample_posterior",description:`<strong>sample_posterior</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to sample from the posterior.`,name:"sample_posterior"},{anchor:"diffusers.AutoencoderKLAllegro.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.AutoencoderKLAllegro.forward.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
PyTorch random number generator.`,name:"generator"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/autoencoder_kl_allegro.py#L1070"}}),P=new ke({props:{title:"AutoencoderKLOutput",local:"diffusers.models.modeling_outputs.AutoencoderKLOutput",headingTag:"h2"}}),z=new v({props:{name:"class diffusers.models.modeling_outputs.AutoencoderKLOutput",anchor:"diffusers.models.modeling_outputs.AutoencoderKLOutput",parameters:[{name:"latent_dist",val:": DiagonalGaussianDistribution"}],parametersDescription:[{anchor:"diffusers.models.modeling_outputs.AutoencoderKLOutput.latent_dist",description:`<strong>latent_dist</strong> (<code>DiagonalGaussianDistribution</code>) &#x2014;
Encoded outputs of <code>Encoder</code> represented as the mean and logvar of <code>DiagonalGaussianDistribution</code>.
<code>DiagonalGaussianDistribution</code> allows for sampling latents from the distribution.`,name:"latent_dist"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/modeling_outputs.py#L6"}}),H=new ke({props:{title:"DecoderOutput",local:"diffusers.models.autoencoders.vae.DecoderOutput",headingTag:"h2"}}),j=new v({props:{name:"class diffusers.models.autoencoders.vae.DecoderOutput",anchor:"diffusers.models.autoencoders.vae.DecoderOutput",parameters:[{name:"sample",val:": Tensor"},{name:"commit_loss",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"diffusers.models.autoencoders.vae.DecoderOutput.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
The decoded output sample from the last layer of the model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/autoencoders/vae.py#L46"}}),J=new it({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/models/autoencoderkl_allegro.md"}}),{c(){A=a("meta"),se=r(),ne=a("p"),le=r(),u(T.$$.fragment),ae=r(),K=a("p"),K.innerHTML=ze,ie=r(),M=a("p"),M.textContent=He,de=r(),u(E.$$.fragment),ce=r(),u(V.$$.fragment),ue=r(),l=a("div"),u(C.$$.fragment),xe=r(),N=a("p"),N.innerHTML=je,De=r(),Z=a("p"),Z.innerHTML=Je,Te=r(),R=a("div"),u(q.$$.fragment),Ke=r(),S=a("div"),u(B.$$.fragment),Me=r(),L=a("div"),u(I.$$.fragment),Ee=r(),W=a("p"),W.innerHTML=Ne,Ve=r(),k=a("div"),u(O.$$.fragment),Ce=r(),X=a("p"),X.innerHTML=Ze,qe=r(),x=a("div"),u(F.$$.fragment),Be=r(),Q=a("p"),Q.textContent=Re,Ie=r(),D=a("div"),u(U.$$.fragment),Oe=r(),Y=a("p"),Y.textContent=Se,Fe=r(),ee=a("div"),u(G.$$.fragment),me=r(),u(P.$$.fragment),pe=r(),w=a("div"),u(z.$$.fragment),Ue=r(),te=a("p"),te.textContent=We,fe=r(),u(H.$$.fragment),ge=r(),y=a("div"),u(j.$$.fragment),Ge=r(),oe=a("p"),oe.textContent=Xe,he=r(),u(J.$$.fragment),be=r(),re=a("p"),this.h()},l(e){const n=lt("svelte-u9bgzb",document.head);A=i(n,"META",{name:!0,content:!0}),n.forEach(t),se=s(e),ne=i(e,"P",{}),b(ne).forEach(t),le=s(e),m(T.$$.fragment,e),ae=s(e),K=i(e,"P",{"data-svelte-h":!0}),$(K)!=="svelte-1pr3axq"&&(K.innerHTML=ze),ie=s(e),M=i(e,"P",{"data-svelte-h":!0}),$(M)!=="svelte-1vuni30"&&(M.textContent=He),de=s(e),m(E.$$.fragment,e),ce=s(e),m(V.$$.fragment,e),ue=s(e),l=i(e,"DIV",{class:!0});var d=b(l);m(C.$$.fragment,d),xe=s(d),N=i(d,"P",{"data-svelte-h":!0}),$(N)!=="svelte-1inj1b4"&&(N.innerHTML=je),De=s(d),Z=i(d,"P",{"data-svelte-h":!0}),$(Z)!=="svelte-1hyu2ru"&&(Z.innerHTML=Je),Te=s(d),R=i(d,"DIV",{class:!0});var Qe=b(R);m(q.$$.fragment,Qe),Qe.forEach(t),Ke=s(d),S=i(d,"DIV",{class:!0});var Ye=b(S);m(B.$$.fragment,Ye),Ye.forEach(t),Me=s(d),L=i(d,"DIV",{class:!0});var $e=b(L);m(I.$$.fragment,$e),Ee=s($e),W=i($e,"P",{"data-svelte-h":!0}),$(W)!=="svelte-189cc7b"&&(W.innerHTML=Ne),$e.forEach(t),Ve=s(d),k=i(d,"DIV",{class:!0});var ve=b(k);m(O.$$.fragment,ve),Ce=s(ve),X=i(ve,"P",{"data-svelte-h":!0}),$(X)!=="svelte-1f366pl"&&(X.innerHTML=Ze),ve.forEach(t),qe=s(d),x=i(d,"DIV",{class:!0});var Ae=b(x);m(F.$$.fragment,Ae),Be=s(Ae),Q=i(Ae,"P",{"data-svelte-h":!0}),$(Q)!=="svelte-14bnrb6"&&(Q.textContent=Re),Ae.forEach(t),Ie=s(d),D=i(d,"DIV",{class:!0});var we=b(D);m(U.$$.fragment,we),Oe=s(we),Y=i(we,"P",{"data-svelte-h":!0}),$(Y)!=="svelte-1xwrf7t"&&(Y.textContent=Se),we.forEach(t),Fe=s(d),ee=i(d,"DIV",{class:!0});var et=b(ee);m(G.$$.fragment,et),et.forEach(t),d.forEach(t),me=s(e),m(P.$$.fragment,e),pe=s(e),w=i(e,"DIV",{class:!0});var ye=b(w);m(z.$$.fragment,ye),Ue=s(ye),te=i(ye,"P",{"data-svelte-h":!0}),$(te)!=="svelte-1vsc7ag"&&(te.textContent=We),ye.forEach(t),fe=s(e),m(H.$$.fragment,e),ge=s(e),y=i(e,"DIV",{class:!0});var Le=b(y);m(j.$$.fragment,Le),Ge=s(Le),oe=i(Le,"P",{"data-svelte-h":!0}),$(oe)!=="svelte-18u8upa"&&(oe.textContent=Xe),Le.forEach(t),he=s(e),m(J.$$.fragment,e),be=s(e),re=i(e,"P",{}),b(re).forEach(t),this.h()},h(){_(A,"name","hf:doc:metadata"),_(A,"content",ct),_(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){o(document.head,A),c(e,se,n),c(e,ne,n),c(e,le,n),p(T,e,n),c(e,ae,n),c(e,K,n),c(e,ie,n),c(e,M,n),c(e,de,n),p(E,e,n),c(e,ce,n),p(V,e,n),c(e,ue,n),c(e,l,n),p(C,l,null),o(l,xe),o(l,N),o(l,De),o(l,Z),o(l,Te),o(l,R),p(q,R,null),o(l,Ke),o(l,S),p(B,S,null),o(l,Me),o(l,L),p(I,L,null),o(L,Ee),o(L,W),o(l,Ve),o(l,k),p(O,k,null),o(k,Ce),o(k,X),o(l,qe),o(l,x),p(F,x,null),o(x,Be),o(x,Q),o(l,Ie),o(l,D),p(U,D,null),o(D,Oe),o(D,Y),o(l,Fe),o(l,ee),p(G,ee,null),c(e,me,n),p(P,e,n),c(e,pe,n),c(e,w,n),p(z,w,null),o(w,Ue),o(w,te),c(e,fe,n),p(H,e,n),c(e,ge,n),c(e,y,n),p(j,y,null),o(y,Ge),o(y,oe),c(e,he,n),p(J,e,n),c(e,be,n),c(e,re,n),_e=!0},p:ot,i(e){_e||(f(T.$$.fragment,e),f(E.$$.fragment,e),f(V.$$.fragment,e),f(C.$$.fragment,e),f(q.$$.fragment,e),f(B.$$.fragment,e),f(I.$$.fragment,e),f(O.$$.fragment,e),f(F.$$.fragment,e),f(U.$$.fragment,e),f(G.$$.fragment,e),f(P.$$.fragment,e),f(z.$$.fragment,e),f(H.$$.fragment,e),f(j.$$.fragment,e),f(J.$$.fragment,e),_e=!0)},o(e){g(T.$$.fragment,e),g(E.$$.fragment,e),g(V.$$.fragment,e),g(C.$$.fragment,e),g(q.$$.fragment,e),g(B.$$.fragment,e),g(I.$$.fragment,e),g(O.$$.fragment,e),g(F.$$.fragment,e),g(U.$$.fragment,e),g(G.$$.fragment,e),g(P.$$.fragment,e),g(z.$$.fragment,e),g(H.$$.fragment,e),g(j.$$.fragment,e),g(J.$$.fragment,e),_e=!1},d(e){e&&(t(se),t(ne),t(le),t(ae),t(K),t(ie),t(M),t(de),t(ce),t(ue),t(l),t(me),t(pe),t(w),t(fe),t(ge),t(y),t(he),t(be),t(re)),t(A),h(T,e),h(E,e),h(V,e),h(C),h(q),h(B),h(I),h(O),h(F),h(U),h(G),h(P,e),h(z),h(H,e),h(j),h(J,e)}}}const ct='{"title":"AutoencoderKLAllegro","local":"autoencoderklallegro","sections":[{"title":"AutoencoderKLAllegro","local":"diffusers.AutoencoderKLAllegro","sections":[],"depth":2},{"title":"AutoencoderKLOutput","local":"diffusers.models.modeling_outputs.AutoencoderKLOutput","sections":[],"depth":2},{"title":"DecoderOutput","local":"diffusers.models.autoencoders.vae.DecoderOutput","sections":[],"depth":2}],"depth":1}';function ut(Pe){return nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bt extends rt{constructor(A){super(),st(this,A,ut,dt,tt,{})}}export{bt as component};
