import{s as de,n as le,o as ce}from"../chunks/scheduler.8c3d61f6.js";import{S as fe,i as ue,g as i,s as r,r as C,A as me,h as a,f as s,c as n,j as G,u as y,x as V,k as I,y as T,a as o,v as F,d as S,t as w,w as L}from"../chunks/index.da70eac4.js";import{D as Y}from"../chunks/Docstring.567bc132.js";import{H as ee,E as pe}from"../chunks/index.5d4ab994.js";function _e(te){let d,D,N,H,f,X,u,se='The ControlNet model was introduced in <a href="https://huggingface.co/papers/2302.05543" rel="nofollow">Adding Conditional Control to Text-to-Image Diffusion Models</a> by Lvmin Zhang, Anyi Rao, Maneesh Agrawala. It provides a greater degree of control over text-to-image generation by conditioning the model on additional inputs such as edge maps, depth maps, segmentation maps, and keypoints for pose detection.',E,m,oe="The abstract from the paper is:",O,p,re="<em>We present ControlNet, a neural network architecture to add spatial conditioning controls to large, pretrained text-to-image diffusion models. ControlNet locks the production-ready large diffusion models, and reuses their deep and robust encoding layers pretrained with billions of images as a strong backbone to learn a diverse set of conditional controls. The neural architecture is connected with “zero convolutions” (zero-initialized convolution layers) that progressively grow the parameters from zero and ensure that no harmful noise could affect the finetuning. We test various conditioning controls, eg, edges, depth, segmentation, human pose, etc, with Stable Diffusion, using single or multiple conditions, with or without prompts. We show that the training of ControlNets is robust with small (&lt;50k) and large (&gt;1m) datasets. Extensive results show that ControlNet may facilitate wider applications to control image diffusion models.</em>",J,_,ne=`This model was contributed by <a href="https://huggingface.co/ishan24" rel="nofollow">ishan24</a>. ❤️
The original codebase can be found at <a href="https://github.com/NVlabs/Sana" rel="nofollow">NVlabs/Sana</a>, and you can find official ControlNet checkpoints on <a href="https://huggingface.co/Efficient-Large-Model" rel="nofollow">Efficient-Large-Model’s</a> Hub profile.`,K,A,R,l,P,B,c,g,Q,M,ie="Sets the attention processor to use to compute attention.",k,h,U,$,b,z,v,j,x,W;return f=new ee({props:{title:"SanaControlNetModel",local:"sanacontrolnetmodel",headingTag:"h1"}}),A=new ee({props:{title:"SanaControlNetModel",local:"diffusers.SanaControlNetModel",headingTag:"h2"}}),P=new Y({props:{name:"class diffusers.SanaControlNetModel",anchor:"diffusers.SanaControlNetModel",parameters:[{name:"in_channels",val:": int = 32"},{name:"out_channels",val:": typing.Optional[int] = 32"},{name:"num_attention_heads",val:": int = 70"},{name:"attention_head_dim",val:": int = 32"},{name:"num_layers",val:": int = 7"},{name:"num_cross_attention_heads",val:": typing.Optional[int] = 20"},{name:"cross_attention_head_dim",val:": typing.Optional[int] = 112"},{name:"cross_attention_dim",val:": typing.Optional[int] = 2240"},{name:"caption_channels",val:": int = 2304"},{name:"mlp_ratio",val:": float = 2.5"},{name:"dropout",val:": float = 0.0"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": int = 32"},{name:"patch_size",val:": int = 1"},{name:"norm_elementwise_affine",val:": bool = False"},{name:"norm_eps",val:": float = 1e-06"},{name:"interpolation_scale",val:": typing.Optional[int] = None"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/controlnets/controlnet_sana.py#L41"}}),g=new Y({props:{name:"set_attn_processor",anchor:"diffusers.SanaControlNetModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.CustomDiffusionAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.JointAttnProcessor2_0, diffusers.models.attention_processor.PAGJointAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGJointAttnProcessor2_0, diffusers.models.attention_processor.FusedJointAttnProcessor2_0, diffusers.models.attention_processor.AllegroAttnProcessor2_0, diffusers.models.attention_processor.AuraFlowAttnProcessor2_0, diffusers.models.attention_processor.FusedAuraFlowAttnProcessor2_0, diffusers.models.attention_processor.FluxAttnProcessor2_0, diffusers.models.attention_processor.FluxAttnProcessor2_0_NPU, diffusers.models.attention_processor.FusedFluxAttnProcessor2_0, diffusers.models.attention_processor.FusedFluxAttnProcessor2_0_NPU, diffusers.models.attention_processor.CogVideoXAttnProcessor2_0, diffusers.models.attention_processor.FusedCogVideoXAttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnAddedKVProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.XLAFlashAttnProcessor2_0, diffusers.models.attention_processor.AttnProcessorNPU, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.MochiVaeAttnProcessor2_0, diffusers.models.attention_processor.MochiAttnProcessor2_0, diffusers.models.attention_processor.StableAudioAttnProcessor2_0, diffusers.models.attention_processor.HunyuanAttnProcessor2_0, diffusers.models.attention_processor.FusedHunyuanAttnProcessor2_0, diffusers.models.attention_processor.PAGHunyuanAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGHunyuanAttnProcessor2_0, diffusers.models.attention_processor.LuminaAttnProcessor2_0, diffusers.models.attention_processor.FusedAttnProcessor2_0, diffusers.models.attention_processor.CustomDiffusionXFormersAttnProcessor, diffusers.models.attention_processor.CustomDiffusionAttnProcessor2_0, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.SanaLinearAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGSanaLinearAttnProcessor2_0, diffusers.models.attention_processor.PAGIdentitySanaLinearAttnProcessor2_0, diffusers.models.attention_processor.SanaMultiscaleLinearAttention, diffusers.models.attention_processor.SanaMultiscaleAttnProcessor2_0, diffusers.models.attention_processor.SanaMultiscaleAttentionProjection, diffusers.models.attention_processor.IPAdapterAttnProcessor, diffusers.models.attention_processor.IPAdapterAttnProcessor2_0, diffusers.models.attention_processor.IPAdapterXFormersAttnProcessor, diffusers.models.attention_processor.SD3IPAdapterJointAttnProcessor2_0, diffusers.models.attention_processor.PAGIdentitySelfAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGIdentitySelfAttnProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAAttnProcessor2_0, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, diffusers.models.attention_processor.LoRAAttnAddedKVProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.CustomDiffusionAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.JointAttnProcessor2_0, diffusers.models.attention_processor.PAGJointAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGJointAttnProcessor2_0, diffusers.models.attention_processor.FusedJointAttnProcessor2_0, diffusers.models.attention_processor.AllegroAttnProcessor2_0, diffusers.models.attention_processor.AuraFlowAttnProcessor2_0, diffusers.models.attention_processor.FusedAuraFlowAttnProcessor2_0, diffusers.models.attention_processor.FluxAttnProcessor2_0, diffusers.models.attention_processor.FluxAttnProcessor2_0_NPU, diffusers.models.attention_processor.FusedFluxAttnProcessor2_0, diffusers.models.attention_processor.FusedFluxAttnProcessor2_0_NPU, diffusers.models.attention_processor.CogVideoXAttnProcessor2_0, diffusers.models.attention_processor.FusedCogVideoXAttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnAddedKVProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.XLAFlashAttnProcessor2_0, diffusers.models.attention_processor.AttnProcessorNPU, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.MochiVaeAttnProcessor2_0, diffusers.models.attention_processor.MochiAttnProcessor2_0, diffusers.models.attention_processor.StableAudioAttnProcessor2_0, diffusers.models.attention_processor.HunyuanAttnProcessor2_0, diffusers.models.attention_processor.FusedHunyuanAttnProcessor2_0, diffusers.models.attention_processor.PAGHunyuanAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGHunyuanAttnProcessor2_0, diffusers.models.attention_processor.LuminaAttnProcessor2_0, diffusers.models.attention_processor.FusedAttnProcessor2_0, diffusers.models.attention_processor.CustomDiffusionXFormersAttnProcessor, diffusers.models.attention_processor.CustomDiffusionAttnProcessor2_0, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.SanaLinearAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGSanaLinearAttnProcessor2_0, diffusers.models.attention_processor.PAGIdentitySanaLinearAttnProcessor2_0, diffusers.models.attention_processor.SanaMultiscaleLinearAttention, diffusers.models.attention_processor.SanaMultiscaleAttnProcessor2_0, diffusers.models.attention_processor.SanaMultiscaleAttentionProjection, diffusers.models.attention_processor.IPAdapterAttnProcessor, diffusers.models.attention_processor.IPAdapterAttnProcessor2_0, diffusers.models.attention_processor.IPAdapterXFormersAttnProcessor, diffusers.models.attention_processor.SD3IPAdapterJointAttnProcessor2_0, diffusers.models.attention_processor.PAGIdentitySelfAttnProcessor2_0, diffusers.models.attention_processor.PAGCFGIdentitySelfAttnProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAAttnProcessor2_0, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, diffusers.models.attention_processor.LoRAAttnAddedKVProcessor]]]"}],parametersDescription:[{anchor:"diffusers.SanaControlNetModel.set_attn_processor.processor",description:`<strong>processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or only <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
for <strong>all</strong> <code>Attention</code> layers.</p>
<p>If <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention
processor. This is strongly recommended when setting trainable attention processors.`,name:"processor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/controlnets/controlnet_sana.py#L146"}}),h=new ee({props:{title:"SanaControlNetOutput",local:"diffusers.models.controlnets.controlnet_sana.SanaControlNetOutput",headingTag:"h2"}}),b=new Y({props:{name:"class diffusers.models.controlnets.controlnet_sana.SanaControlNetOutput",anchor:"diffusers.models.controlnets.controlnet_sana.SanaControlNetOutput",parameters:[{name:"controlnet_block_samples",val:": typing.Tuple[torch.Tensor]"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/controlnets/controlnet_sana.py#L36"}}),v=new pe({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/models/controlnet_sana.md"}}),{c(){d=i("meta"),D=r(),N=i("p"),H=r(),C(f.$$.fragment),X=r(),u=i("p"),u.innerHTML=se,E=r(),m=i("p"),m.textContent=oe,O=r(),p=i("p"),p.innerHTML=re,J=r(),_=i("p"),_.innerHTML=ne,K=r(),C(A.$$.fragment),R=r(),l=i("div"),C(P.$$.fragment),B=r(),c=i("div"),C(g.$$.fragment),Q=r(),M=i("p"),M.textContent=ie,k=r(),C(h.$$.fragment),U=r(),$=i("div"),C(b.$$.fragment),z=r(),C(v.$$.fragment),j=r(),x=i("p"),this.h()},l(e){const t=me("svelte-u9bgzb",document.head);d=a(t,"META",{name:!0,content:!0}),t.forEach(s),D=n(e),N=a(e,"P",{}),G(N).forEach(s),H=n(e),y(f.$$.fragment,e),X=n(e),u=a(e,"P",{"data-svelte-h":!0}),V(u)!=="svelte-1s65p96"&&(u.innerHTML=se),E=n(e),m=a(e,"P",{"data-svelte-h":!0}),V(m)!=="svelte-1cwsb16"&&(m.textContent=oe),O=n(e),p=a(e,"P",{"data-svelte-h":!0}),V(p)!=="svelte-fbiw6t"&&(p.innerHTML=re),J=n(e),_=a(e,"P",{"data-svelte-h":!0}),V(_)!=="svelte-106mph8"&&(_.innerHTML=ne),K=n(e),y(A.$$.fragment,e),R=n(e),l=a(e,"DIV",{class:!0});var q=G(l);y(P.$$.fragment,q),B=n(q),c=a(q,"DIV",{class:!0});var Z=G(c);y(g.$$.fragment,Z),Q=n(Z),M=a(Z,"P",{"data-svelte-h":!0}),V(M)!=="svelte-1o77hl2"&&(M.textContent=ie),Z.forEach(s),q.forEach(s),k=n(e),y(h.$$.fragment,e),U=n(e),$=a(e,"DIV",{class:!0});var ae=G($);y(b.$$.fragment,ae),ae.forEach(s),z=n(e),y(v.$$.fragment,e),j=n(e),x=a(e,"P",{}),G(x).forEach(s),this.h()},h(){I(d,"name","hf:doc:metadata"),I(d,"content",Ae),I(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),I(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),I($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){T(document.head,d),o(e,D,t),o(e,N,t),o(e,H,t),F(f,e,t),o(e,X,t),o(e,u,t),o(e,E,t),o(e,m,t),o(e,O,t),o(e,p,t),o(e,J,t),o(e,_,t),o(e,K,t),F(A,e,t),o(e,R,t),o(e,l,t),F(P,l,null),T(l,B),T(l,c),F(g,c,null),T(c,Q),T(c,M),o(e,k,t),F(h,e,t),o(e,U,t),o(e,$,t),F(b,$,null),o(e,z,t),F(v,e,t),o(e,j,t),o(e,x,t),W=!0},p:le,i(e){W||(S(f.$$.fragment,e),S(A.$$.fragment,e),S(P.$$.fragment,e),S(g.$$.fragment,e),S(h.$$.fragment,e),S(b.$$.fragment,e),S(v.$$.fragment,e),W=!0)},o(e){w(f.$$.fragment,e),w(A.$$.fragment,e),w(P.$$.fragment,e),w(g.$$.fragment,e),w(h.$$.fragment,e),w(b.$$.fragment,e),w(v.$$.fragment,e),W=!1},d(e){e&&(s(D),s(N),s(H),s(X),s(u),s(E),s(m),s(O),s(p),s(J),s(_),s(K),s(R),s(l),s(k),s(U),s($),s(z),s(j),s(x)),s(d),L(f,e),L(A,e),L(P),L(g),L(h,e),L(b),L(v,e)}}}const Ae='{"title":"SanaControlNetModel","local":"sanacontrolnetmodel","sections":[{"title":"SanaControlNetModel","local":"diffusers.SanaControlNetModel","sections":[],"depth":2},{"title":"SanaControlNetOutput","local":"diffusers.models.controlnets.controlnet_sana.SanaControlNetOutput","sections":[],"depth":2}],"depth":1}';function Pe(te){return ce(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ve extends fe{constructor(d){super(),ue(this,d,Pe,_e,de,{})}}export{ve as component};
