import{s as mr,n as dr,o as lr}from"../chunks/scheduler.8c3d61f6.js";import{S as fr,i as ur,g as u,s as t,r as a,A as gr,h as g,f as r,c as i,j as c,u as s,x as _,k as $,y as p,a as n,v as m,d,t as l,w as f}from"../chunks/index.da70eac4.js";import{D as h}from"../chunks/Docstring.567bc132.js";import{H as b,E as pr}from"../chunks/index.5d4ab994.js";function cr(ko){let y,Re,Me,Ve,D,Pe,R,Fo="Customized normalization layers for supporting various models in 🤗 Diffusers.",Ie,V,Ee,N,P,So,he,Oo="Norm layer modified to incorporate timestep embeddings.",Ge,I,Xe,z,E,Zo,_e,jo="Norm layer adaptive layer norm zero (adaLN-Zero).",qe,G,He,v,X,Mo,ve,Bo="Norm layer adaptive layer norm single (adaLN-single).",Do,ye,Uo='As proposed in PixArt-Alpha (see: <a href="https://arxiv.org/abs/2310.00426" rel="nofollow">https://arxiv.org/abs/2310.00426</a>; Section 2.3).',ke,q,Fe,L,H,Ro,Ne,Jo="GroupNorm layer modified to incorporate timestep embeddings.",Oe,k,je,x,F,Vo,ze,Ko="Adaptive normalization layer with a norm layer (layer_norm or rms_norm).",Be,O,Ue,A,j,Po,Le,Qo='RMS Norm as introduced in <a href="https://arxiv.org/abs/1910.07467" rel="nofollow">https://arxiv.org/abs/1910.07467</a> by Zhang et al.',Je,B,Ke,w,U,Io,xe,Wo='Global response normalization as introduced in ConvNeXt-v2 (<a href="https://arxiv.org/abs/2301.00808" rel="nofollow">https://arxiv.org/abs/2301.00808</a>).',Qe,J,We,K,Q,Ye,W,eo,C,Y,Eo,Ae,Yo="Norm layer adaptive layer norm zero (AdaLN-Zero).",oo,ee,ro,T,oe,Go,we,er="Norm layer adaptive layer norm zero (adaLN-Zero).",no,re,to,S,ne,Xo,Ce,or="Norm layer adaptive RMS normalization zero.",io,te,ao,ie,ae,so,se,mo,Z,me,qo,Te,rr="Norm layer adaptive layer norm zero (adaLN-Zero).",lo,de,fo,le,fe,uo,ue,go,M,ge,Ho,Se,nr="Adaptive RMS Norm used in Mochi.",po,pe,co,ce,$e,$o,be,bo,De,ho;return D=new b({props:{title:"Normalization layers",local:"normalization-layers",headingTag:"h1"}}),V=new b({props:{title:"AdaLayerNorm",local:"diffusers.models.normalization.AdaLayerNorm",headingTag:"h2"}}),P=new h({props:{name:"class diffusers.models.normalization.AdaLayerNorm",anchor:"diffusers.models.normalization.AdaLayerNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": typing.Optional[int] = None"},{name:"output_dim",val:": typing.Optional[int] = None"},{name:"norm_elementwise_affine",val:": bool = False"},{name:"norm_eps",val:": float = 1e-05"},{name:"chunk_dim",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>, <em>optional</em>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"},{anchor:"diffusers.models.normalization.AdaLayerNorm.output_dim",description:"<strong>output_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014;",name:"output_dim"},{anchor:"diffusers.models.normalization.AdaLayerNorm.norm_elementwise_affine",description:"<strong>norm_elementwise_affine</strong> (<code>bool</code>, defaults to `False) &#x2014;",name:"norm_elementwise_affine"},{anchor:"diffusers.models.normalization.AdaLayerNorm.norm_eps",description:"<strong>norm_eps</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;",name:"norm_eps"},{anchor:"diffusers.models.normalization.AdaLayerNorm.chunk_dim",description:"<strong>chunk_dim</strong> (<code>int</code>, defaults to <code>0</code>) &#x2014;",name:"chunk_dim"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L28"}}),I=new b({props:{title:"AdaLayerNormZero",local:"diffusers.models.normalization.AdaLayerNormZero",headingTag:"h2"}}),E=new h({props:{name:"class diffusers.models.normalization.AdaLayerNormZero",anchor:"diffusers.models.normalization.AdaLayerNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": typing.Optional[int] = None"},{name:"norm_type",val:" = 'layer_norm'"},{name:"bias",val:" = True"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormZero.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L131"}}),G=new b({props:{title:"AdaLayerNormSingle",local:"diffusers.models.normalization.AdaLayerNormSingle",headingTag:"h2"}}),X=new h({props:{name:"class diffusers.models.normalization.AdaLayerNormSingle",anchor:"diffusers.models.normalization.AdaLayerNormSingle",parameters:[{name:"embedding_dim",val:": int"},{name:"use_additional_conditions",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormSingle.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormSingle.use_additional_conditions",description:"<strong>use_additional_conditions</strong> (<code>bool</code>) &#x2014; To use additional conditions for normalization or not.",name:"use_additional_conditions"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L236"}}),q=new b({props:{title:"AdaGroupNorm",local:"diffusers.models.normalization.AdaGroupNorm",headingTag:"h2"}}),H=new h({props:{name:"class diffusers.models.normalization.AdaGroupNorm",anchor:"diffusers.models.normalization.AdaGroupNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"out_dim",val:": int"},{name:"num_groups",val:": int"},{name:"act_fn",val:": typing.Optional[str] = None"},{name:"eps",val:": float = 1e-05"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaGroupNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_groups",description:"<strong>num_groups</strong> (<code>int</code>) &#x2014; The number of groups to separate the channels into.",name:"num_groups"},{anchor:"diffusers.models.normalization.AdaGroupNorm.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.models.normalization.AdaGroupNorm.eps",description:"<strong>eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon value to use for numerical stability.",name:"eps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L270"}}),k=new b({props:{title:"AdaLayerNormContinuous",local:"diffusers.models.normalization.AdaLayerNormContinuous",headingTag:"h2"}}),F=new h({props:{name:"class diffusers.models.normalization.AdaLayerNormContinuous",anchor:"diffusers.models.normalization.AdaLayerNormContinuous",parameters:[{name:"embedding_dim",val:": int"},{name:"conditioning_embedding_dim",val:": int"},{name:"elementwise_affine",val:" = True"},{name:"eps",val:" = 1e-05"},{name:"bias",val:" = True"},{name:"norm_type",val:" = 'layer_norm'"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; Embedding dimension to use during projection.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.conditioning_embedding_dim",description:"<strong>conditioning_embedding_dim</strong> (<code>int</code>) &#x2014; Dimension of the input condition.",name:"conditioning_embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.elementwise_affine",description:`<strong>elementwise_affine</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Boolean flag to denote if affine transformation should be applied.`,name:"elementwise_affine"},{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.eps",description:"<strong>eps</strong> (<code>float</code>, defaults to 1e-5) &#x2014; Epsilon factor.",name:"eps"},{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.bias",description:"<strong>bias</strong> (<code>bias</code>, defaults to <code>True</code>) &#x2014; Boolean flag to denote if bias should be use.",name:"bias"},{anchor:"diffusers.models.normalization.AdaLayerNormContinuous.norm_type",description:`<strong>norm_type</strong> (<code>str</code>, defaults to <code>&quot;layer_norm&quot;</code>) &#x2014;
Normalization layer to use. Values supported: &#x201C;layer_norm&#x201D;, &#x201C;rms_norm&#x201D;.`,name:"norm_type"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L308"}}),O=new b({props:{title:"RMSNorm",local:"diffusers.models.normalization.RMSNorm",headingTag:"h2"}}),j=new h({props:{name:"class diffusers.models.normalization.RMSNorm",anchor:"diffusers.models.normalization.RMSNorm",parameters:[{name:"dim",val:""},{name:"eps",val:": float"},{name:"elementwise_affine",val:": bool = True"},{name:"bias",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.normalization.RMSNorm.dim",description:"<strong>dim</strong> (<code>int</code>) &#x2014; Number of dimensions to use for <code>weights</code>. Only effective when <code>elementwise_affine</code> is True.",name:"dim"},{anchor:"diffusers.models.normalization.RMSNorm.eps",description:"<strong>eps</strong> (<code>float</code>) &#x2014; Small value to use when calculating the reciprocal of the square-root.",name:"eps"},{anchor:"diffusers.models.normalization.RMSNorm.elementwise_affine",description:`<strong>elementwise_affine</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Boolean flag to denote if affine transformation should be applied.`,name:"elementwise_affine"},{anchor:"diffusers.models.normalization.RMSNorm.bias",description:"<strong>bias</strong> (<code>bool</code>, defaults to False) &#x2014; If also training the <code>bias</code> param.",name:"bias"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L511"}}),B=new b({props:{title:"GlobalResponseNorm",local:"diffusers.models.normalization.GlobalResponseNorm",headingTag:"h2"}}),U=new h({props:{name:"class diffusers.models.normalization.GlobalResponseNorm",anchor:"diffusers.models.normalization.GlobalResponseNorm",parameters:[{name:"dim",val:""}],parametersDescription:[{anchor:"diffusers.models.normalization.GlobalResponseNorm.dim",description:"<strong>dim</strong> (<code>int</code>) &#x2014; Number of dimensions to use for the <code>gamma</code> and <code>beta</code>.",name:"dim"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L601"}}),J=new b({props:{title:"LuminaLayerNormContinuous",local:"diffusers.models.normalization.LuminaLayerNormContinuous",headingTag:"h2"}}),Q=new h({props:{name:"class diffusers.models.normalization.LuminaLayerNormContinuous",anchor:"diffusers.models.normalization.LuminaLayerNormContinuous",parameters:[{name:"embedding_dim",val:": int"},{name:"conditioning_embedding_dim",val:": int"},{name:"elementwise_affine",val:" = True"},{name:"eps",val:" = 1e-05"},{name:"bias",val:" = True"},{name:"norm_type",val:" = 'layer_norm'"},{name:"out_dim",val:": typing.Optional[int] = None"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L355"}}),W=new b({props:{title:"SD35AdaLayerNormZeroX",local:"diffusers.models.normalization.SD35AdaLayerNormZeroX",headingTag:"h2"}}),Y=new h({props:{name:"class diffusers.models.normalization.SD35AdaLayerNormZeroX",anchor:"diffusers.models.normalization.SD35AdaLayerNormZeroX",parameters:[{name:"embedding_dim",val:": int"},{name:"norm_type",val:": str = 'layer_norm'"},{name:"bias",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.normalization.SD35AdaLayerNormZeroX.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.SD35AdaLayerNormZeroX.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L97"}}),ee=new b({props:{title:"AdaLayerNormZeroSingle",local:"diffusers.models.normalization.AdaLayerNormZeroSingle",headingTag:"h2"}}),oe=new h({props:{name:"class diffusers.models.normalization.AdaLayerNormZeroSingle",anchor:"diffusers.models.normalization.AdaLayerNormZeroSingle",parameters:[{name:"embedding_dim",val:": int"},{name:"norm_type",val:" = 'layer_norm'"},{name:"bias",val:" = True"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormZeroSingle.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormZeroSingle.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L174"}}),re=new b({props:{title:"LuminaRMSNormZero",local:"diffusers.models.normalization.LuminaRMSNormZero",headingTag:"h2"}}),ne=new h({props:{name:"class diffusers.models.normalization.LuminaRMSNormZero",anchor:"diffusers.models.normalization.LuminaRMSNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"norm_eps",val:": float"},{name:"norm_elementwise_affine",val:": bool"}],parametersDescription:[{anchor:"diffusers.models.normalization.LuminaRMSNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L206"}}),te=new b({props:{title:"LpNorm",local:"diffusers.models.normalization.LpNorm",headingTag:"h2"}}),ae=new h({props:{name:"class diffusers.models.normalization.LpNorm",anchor:"diffusers.models.normalization.LpNorm",parameters:[{name:"p",val:": int = 2"},{name:"dim",val:": int = -1"},{name:"eps",val:": float = 1e-12"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L621"}}),se=new b({props:{title:"CogView3PlusAdaLayerNormZeroTextImage",local:"diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage",headingTag:"h2"}}),me=new h({props:{name:"class diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage",anchor:"diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage",parameters:[{name:"embedding_dim",val:": int"},{name:"dim",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L404"}}),de=new b({props:{title:"CogVideoXLayerNormZero",local:"diffusers.models.normalization.CogVideoXLayerNormZero",headingTag:"h2"}}),fe=new h({props:{name:"class diffusers.models.normalization.CogVideoXLayerNormZero",anchor:"diffusers.models.normalization.CogVideoXLayerNormZero",parameters:[{name:"conditioning_dim",val:": int"},{name:"embedding_dim",val:": int"},{name:"elementwise_affine",val:": bool = True"},{name:"eps",val:": float = 1e-05"},{name:"bias",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L449"}}),ue=new b({props:{title:"MochiRMSNormZero",local:"diffusers.models.transformers.transformer_mochi.MochiRMSNormZero",headingTag:"h2"}}),ge=new h({props:{name:"class diffusers.models.transformers.transformer_mochi.MochiRMSNormZero",anchor:"diffusers.models.transformers.transformer_mochi.MochiRMSNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"hidden_dim",val:": int"},{name:"eps",val:": float = 1e-05"},{name:"elementwise_affine",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.transformers.transformer_mochi.MochiRMSNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/transformers/transformer_mochi.py#L88"}}),pe=new b({props:{title:"MochiRMSNorm",local:"diffusers.models.normalization.MochiRMSNorm",headingTag:"h2"}}),$e=new h({props:{name:"class diffusers.models.normalization.MochiRMSNorm",anchor:"diffusers.models.normalization.MochiRMSNorm",parameters:[{name:"dim",val:""},{name:"eps",val:": float"},{name:"elementwise_affine",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/normalization.py#L573"}}),be=new pr({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/normalization.md"}}),{c(){y=u("meta"),Re=t(),Me=u("p"),Ve=t(),a(D.$$.fragment),Pe=t(),R=u("p"),R.textContent=Fo,Ie=t(),a(V.$$.fragment),Ee=t(),N=u("div"),a(P.$$.fragment),So=t(),he=u("p"),he.textContent=Oo,Ge=t(),a(I.$$.fragment),Xe=t(),z=u("div"),a(E.$$.fragment),Zo=t(),_e=u("p"),_e.textContent=jo,qe=t(),a(G.$$.fragment),He=t(),v=u("div"),a(X.$$.fragment),Mo=t(),ve=u("p"),ve.textContent=Bo,Do=t(),ye=u("p"),ye.innerHTML=Uo,ke=t(),a(q.$$.fragment),Fe=t(),L=u("div"),a(H.$$.fragment),Ro=t(),Ne=u("p"),Ne.textContent=Jo,Oe=t(),a(k.$$.fragment),je=t(),x=u("div"),a(F.$$.fragment),Vo=t(),ze=u("p"),ze.textContent=Ko,Be=t(),a(O.$$.fragment),Ue=t(),A=u("div"),a(j.$$.fragment),Po=t(),Le=u("p"),Le.innerHTML=Qo,Je=t(),a(B.$$.fragment),Ke=t(),w=u("div"),a(U.$$.fragment),Io=t(),xe=u("p"),xe.innerHTML=Wo,Qe=t(),a(J.$$.fragment),We=t(),K=u("div"),a(Q.$$.fragment),Ye=t(),a(W.$$.fragment),eo=t(),C=u("div"),a(Y.$$.fragment),Eo=t(),Ae=u("p"),Ae.textContent=Yo,oo=t(),a(ee.$$.fragment),ro=t(),T=u("div"),a(oe.$$.fragment),Go=t(),we=u("p"),we.textContent=er,no=t(),a(re.$$.fragment),to=t(),S=u("div"),a(ne.$$.fragment),Xo=t(),Ce=u("p"),Ce.textContent=or,io=t(),a(te.$$.fragment),ao=t(),ie=u("div"),a(ae.$$.fragment),so=t(),a(se.$$.fragment),mo=t(),Z=u("div"),a(me.$$.fragment),qo=t(),Te=u("p"),Te.textContent=rr,lo=t(),a(de.$$.fragment),fo=t(),le=u("div"),a(fe.$$.fragment),uo=t(),a(ue.$$.fragment),go=t(),M=u("div"),a(ge.$$.fragment),Ho=t(),Se=u("p"),Se.textContent=nr,po=t(),a(pe.$$.fragment),co=t(),ce=u("div"),a($e.$$.fragment),$o=t(),a(be.$$.fragment),bo=t(),De=u("p"),this.h()},l(e){const o=gr("svelte-u9bgzb",document.head);y=g(o,"META",{name:!0,content:!0}),o.forEach(r),Re=i(e),Me=g(e,"P",{}),c(Me).forEach(r),Ve=i(e),s(D.$$.fragment,e),Pe=i(e),R=g(e,"P",{"data-svelte-h":!0}),_(R)!=="svelte-i4ltwe"&&(R.textContent=Fo),Ie=i(e),s(V.$$.fragment,e),Ee=i(e),N=g(e,"DIV",{class:!0});var _o=c(N);s(P.$$.fragment,_o),So=i(_o),he=g(_o,"P",{"data-svelte-h":!0}),_(he)!=="svelte-3m9blw"&&(he.textContent=Oo),_o.forEach(r),Ge=i(e),s(I.$$.fragment,e),Xe=i(e),z=g(e,"DIV",{class:!0});var vo=c(z);s(E.$$.fragment,vo),Zo=i(vo),_e=g(vo,"P",{"data-svelte-h":!0}),_(_e)!=="svelte-hxuhdq"&&(_e.textContent=jo),vo.forEach(r),qe=i(e),s(G.$$.fragment,e),He=i(e),v=g(e,"DIV",{class:!0});var Ze=c(v);s(X.$$.fragment,Ze),Mo=i(Ze),ve=g(Ze,"P",{"data-svelte-h":!0}),_(ve)!=="svelte-b3hofq"&&(ve.textContent=Bo),Do=i(Ze),ye=g(Ze,"P",{"data-svelte-h":!0}),_(ye)!=="svelte-85nsxw"&&(ye.innerHTML=Uo),Ze.forEach(r),ke=i(e),s(q.$$.fragment,e),Fe=i(e),L=g(e,"DIV",{class:!0});var yo=c(L);s(H.$$.fragment,yo),Ro=i(yo),Ne=g(yo,"P",{"data-svelte-h":!0}),_(Ne)!=="svelte-gj85yz"&&(Ne.textContent=Jo),yo.forEach(r),Oe=i(e),s(k.$$.fragment,e),je=i(e),x=g(e,"DIV",{class:!0});var No=c(x);s(F.$$.fragment,No),Vo=i(No),ze=g(No,"P",{"data-svelte-h":!0}),_(ze)!=="svelte-1bssxjn"&&(ze.textContent=Ko),No.forEach(r),Be=i(e),s(O.$$.fragment,e),Ue=i(e),A=g(e,"DIV",{class:!0});var zo=c(A);s(j.$$.fragment,zo),Po=i(zo),Le=g(zo,"P",{"data-svelte-h":!0}),_(Le)!=="svelte-dsaf0w"&&(Le.innerHTML=Qo),zo.forEach(r),Je=i(e),s(B.$$.fragment,e),Ke=i(e),w=g(e,"DIV",{class:!0});var Lo=c(w);s(U.$$.fragment,Lo),Io=i(Lo),xe=g(Lo,"P",{"data-svelte-h":!0}),_(xe)!=="svelte-32fkd3"&&(xe.innerHTML=Wo),Lo.forEach(r),Qe=i(e),s(J.$$.fragment,e),We=i(e),K=g(e,"DIV",{class:!0});var tr=c(K);s(Q.$$.fragment,tr),tr.forEach(r),Ye=i(e),s(W.$$.fragment,e),eo=i(e),C=g(e,"DIV",{class:!0});var xo=c(C);s(Y.$$.fragment,xo),Eo=i(xo),Ae=g(xo,"P",{"data-svelte-h":!0}),_(Ae)!=="svelte-fco2xq"&&(Ae.textContent=Yo),xo.forEach(r),oo=i(e),s(ee.$$.fragment,e),ro=i(e),T=g(e,"DIV",{class:!0});var Ao=c(T);s(oe.$$.fragment,Ao),Go=i(Ao),we=g(Ao,"P",{"data-svelte-h":!0}),_(we)!=="svelte-hxuhdq"&&(we.textContent=er),Ao.forEach(r),no=i(e),s(re.$$.fragment,e),to=i(e),S=g(e,"DIV",{class:!0});var wo=c(S);s(ne.$$.fragment,wo),Xo=i(wo),Ce=g(wo,"P",{"data-svelte-h":!0}),_(Ce)!=="svelte-1uwshys"&&(Ce.textContent=or),wo.forEach(r),io=i(e),s(te.$$.fragment,e),ao=i(e),ie=g(e,"DIV",{class:!0});var ir=c(ie);s(ae.$$.fragment,ir),ir.forEach(r),so=i(e),s(se.$$.fragment,e),mo=i(e),Z=g(e,"DIV",{class:!0});var Co=c(Z);s(me.$$.fragment,Co),qo=i(Co),Te=g(Co,"P",{"data-svelte-h":!0}),_(Te)!=="svelte-hxuhdq"&&(Te.textContent=rr),Co.forEach(r),lo=i(e),s(de.$$.fragment,e),fo=i(e),le=g(e,"DIV",{class:!0});var ar=c(le);s(fe.$$.fragment,ar),ar.forEach(r),uo=i(e),s(ue.$$.fragment,e),go=i(e),M=g(e,"DIV",{class:!0});var To=c(M);s(ge.$$.fragment,To),Ho=i(To),Se=g(To,"P",{"data-svelte-h":!0}),_(Se)!=="svelte-4dbwke"&&(Se.textContent=nr),To.forEach(r),po=i(e),s(pe.$$.fragment,e),co=i(e),ce=g(e,"DIV",{class:!0});var sr=c(ce);s($e.$$.fragment,sr),sr.forEach(r),$o=i(e),s(be.$$.fragment,e),bo=i(e),De=g(e,"P",{}),c(De).forEach(r),this.h()},h(){$(y,"name","hf:doc:metadata"),$(y,"content",$r),$(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){p(document.head,y),n(e,Re,o),n(e,Me,o),n(e,Ve,o),m(D,e,o),n(e,Pe,o),n(e,R,o),n(e,Ie,o),m(V,e,o),n(e,Ee,o),n(e,N,o),m(P,N,null),p(N,So),p(N,he),n(e,Ge,o),m(I,e,o),n(e,Xe,o),n(e,z,o),m(E,z,null),p(z,Zo),p(z,_e),n(e,qe,o),m(G,e,o),n(e,He,o),n(e,v,o),m(X,v,null),p(v,Mo),p(v,ve),p(v,Do),p(v,ye),n(e,ke,o),m(q,e,o),n(e,Fe,o),n(e,L,o),m(H,L,null),p(L,Ro),p(L,Ne),n(e,Oe,o),m(k,e,o),n(e,je,o),n(e,x,o),m(F,x,null),p(x,Vo),p(x,ze),n(e,Be,o),m(O,e,o),n(e,Ue,o),n(e,A,o),m(j,A,null),p(A,Po),p(A,Le),n(e,Je,o),m(B,e,o),n(e,Ke,o),n(e,w,o),m(U,w,null),p(w,Io),p(w,xe),n(e,Qe,o),m(J,e,o),n(e,We,o),n(e,K,o),m(Q,K,null),n(e,Ye,o),m(W,e,o),n(e,eo,o),n(e,C,o),m(Y,C,null),p(C,Eo),p(C,Ae),n(e,oo,o),m(ee,e,o),n(e,ro,o),n(e,T,o),m(oe,T,null),p(T,Go),p(T,we),n(e,no,o),m(re,e,o),n(e,to,o),n(e,S,o),m(ne,S,null),p(S,Xo),p(S,Ce),n(e,io,o),m(te,e,o),n(e,ao,o),n(e,ie,o),m(ae,ie,null),n(e,so,o),m(se,e,o),n(e,mo,o),n(e,Z,o),m(me,Z,null),p(Z,qo),p(Z,Te),n(e,lo,o),m(de,e,o),n(e,fo,o),n(e,le,o),m(fe,le,null),n(e,uo,o),m(ue,e,o),n(e,go,o),n(e,M,o),m(ge,M,null),p(M,Ho),p(M,Se),n(e,po,o),m(pe,e,o),n(e,co,o),n(e,ce,o),m($e,ce,null),n(e,$o,o),m(be,e,o),n(e,bo,o),n(e,De,o),ho=!0},p:dr,i(e){ho||(d(D.$$.fragment,e),d(V.$$.fragment,e),d(P.$$.fragment,e),d(I.$$.fragment,e),d(E.$$.fragment,e),d(G.$$.fragment,e),d(X.$$.fragment,e),d(q.$$.fragment,e),d(H.$$.fragment,e),d(k.$$.fragment,e),d(F.$$.fragment,e),d(O.$$.fragment,e),d(j.$$.fragment,e),d(B.$$.fragment,e),d(U.$$.fragment,e),d(J.$$.fragment,e),d(Q.$$.fragment,e),d(W.$$.fragment,e),d(Y.$$.fragment,e),d(ee.$$.fragment,e),d(oe.$$.fragment,e),d(re.$$.fragment,e),d(ne.$$.fragment,e),d(te.$$.fragment,e),d(ae.$$.fragment,e),d(se.$$.fragment,e),d(me.$$.fragment,e),d(de.$$.fragment,e),d(fe.$$.fragment,e),d(ue.$$.fragment,e),d(ge.$$.fragment,e),d(pe.$$.fragment,e),d($e.$$.fragment,e),d(be.$$.fragment,e),ho=!0)},o(e){l(D.$$.fragment,e),l(V.$$.fragment,e),l(P.$$.fragment,e),l(I.$$.fragment,e),l(E.$$.fragment,e),l(G.$$.fragment,e),l(X.$$.fragment,e),l(q.$$.fragment,e),l(H.$$.fragment,e),l(k.$$.fragment,e),l(F.$$.fragment,e),l(O.$$.fragment,e),l(j.$$.fragment,e),l(B.$$.fragment,e),l(U.$$.fragment,e),l(J.$$.fragment,e),l(Q.$$.fragment,e),l(W.$$.fragment,e),l(Y.$$.fragment,e),l(ee.$$.fragment,e),l(oe.$$.fragment,e),l(re.$$.fragment,e),l(ne.$$.fragment,e),l(te.$$.fragment,e),l(ae.$$.fragment,e),l(se.$$.fragment,e),l(me.$$.fragment,e),l(de.$$.fragment,e),l(fe.$$.fragment,e),l(ue.$$.fragment,e),l(ge.$$.fragment,e),l(pe.$$.fragment,e),l($e.$$.fragment,e),l(be.$$.fragment,e),ho=!1},d(e){e&&(r(Re),r(Me),r(Ve),r(Pe),r(R),r(Ie),r(Ee),r(N),r(Ge),r(Xe),r(z),r(qe),r(He),r(v),r(ke),r(Fe),r(L),r(Oe),r(je),r(x),r(Be),r(Ue),r(A),r(Je),r(Ke),r(w),r(Qe),r(We),r(K),r(Ye),r(eo),r(C),r(oo),r(ro),r(T),r(no),r(to),r(S),r(io),r(ao),r(ie),r(so),r(mo),r(Z),r(lo),r(fo),r(le),r(uo),r(go),r(M),r(po),r(co),r(ce),r($o),r(bo),r(De)),r(y),f(D,e),f(V,e),f(P),f(I,e),f(E),f(G,e),f(X),f(q,e),f(H),f(k,e),f(F),f(O,e),f(j),f(B,e),f(U),f(J,e),f(Q),f(W,e),f(Y),f(ee,e),f(oe),f(re,e),f(ne),f(te,e),f(ae),f(se,e),f(me),f(de,e),f(fe),f(ue,e),f(ge),f(pe,e),f($e),f(be,e)}}}const $r='{"title":"Normalization layers","local":"normalization-layers","sections":[{"title":"AdaLayerNorm","local":"diffusers.models.normalization.AdaLayerNorm","sections":[],"depth":2},{"title":"AdaLayerNormZero","local":"diffusers.models.normalization.AdaLayerNormZero","sections":[],"depth":2},{"title":"AdaLayerNormSingle","local":"diffusers.models.normalization.AdaLayerNormSingle","sections":[],"depth":2},{"title":"AdaGroupNorm","local":"diffusers.models.normalization.AdaGroupNorm","sections":[],"depth":2},{"title":"AdaLayerNormContinuous","local":"diffusers.models.normalization.AdaLayerNormContinuous","sections":[],"depth":2},{"title":"RMSNorm","local":"diffusers.models.normalization.RMSNorm","sections":[],"depth":2},{"title":"GlobalResponseNorm","local":"diffusers.models.normalization.GlobalResponseNorm","sections":[],"depth":2},{"title":"LuminaLayerNormContinuous","local":"diffusers.models.normalization.LuminaLayerNormContinuous","sections":[],"depth":2},{"title":"SD35AdaLayerNormZeroX","local":"diffusers.models.normalization.SD35AdaLayerNormZeroX","sections":[],"depth":2},{"title":"AdaLayerNormZeroSingle","local":"diffusers.models.normalization.AdaLayerNormZeroSingle","sections":[],"depth":2},{"title":"LuminaRMSNormZero","local":"diffusers.models.normalization.LuminaRMSNormZero","sections":[],"depth":2},{"title":"LpNorm","local":"diffusers.models.normalization.LpNorm","sections":[],"depth":2},{"title":"CogView3PlusAdaLayerNormZeroTextImage","local":"diffusers.models.normalization.CogView3PlusAdaLayerNormZeroTextImage","sections":[],"depth":2},{"title":"CogVideoXLayerNormZero","local":"diffusers.models.normalization.CogVideoXLayerNormZero","sections":[],"depth":2},{"title":"MochiRMSNormZero","local":"diffusers.models.transformers.transformer_mochi.MochiRMSNormZero","sections":[],"depth":2},{"title":"MochiRMSNorm","local":"diffusers.models.normalization.MochiRMSNorm","sections":[],"depth":2}],"depth":1}';function br(ko){return lr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Nr extends fr{constructor(y){super(),ur(this,y,br,cr,mr,{})}}export{Nr as component};
